/**********************************************************************
 * Copyright (c) 2007 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Template.java,v 1.8 2007/11/07 18:41:34 sleeloy Exp $
 **********************************************************************/
package org.eclipse.cosmos.provisional.dr.ps.common;



public class Template {

	protected String viewId;
	
	protected String debugContainer;
	
	protected String dojoPath;
	
	
	public void setDojoPath(String dojoPath) {
		this.dojoPath = dojoPath;
	}


	/**
	 * Generates html output that represents required header text (i.e. includes required scripts and dojo types).
	 * @param styleFile
	 * @return html output
	 */
	public String header(){
		StringBuffer out = new StringBuffer();
		//include dojo
		out.append("<script type=\"text/javascript\" src=\""+dojoPath+"/dojo/dojo.js\" djConfig=\"isDebug: "+((debugContainer != null)?"true":"false")+", parseOnLoad: true\"></script>\n").
		append("</script>\n");			

		//assume cosmos widgets are stored under '../cosmos' relative to the dojo widget library
		out.append("<script>").
		append("dojo.registerModulePath(\"org.eclipse.cosmos\",\"../../js/org/eclipse/cosmos\");").
		append("dojo.require(\"org.eclipse.cosmos.provisional.dr.ps.components.widget.common\");").		
		append("dojo.require(\"org.eclipse.cosmos.provisional.dr.ps.components.utility.common\");").		
		append("dojo.require(\"dojo.parser\");").		
		append("</script>");		
		return out.toString();
	}
	

 	public void setView(String view){
 		this.viewId  = view;
 	}
 	
 	public String getView(){
		return "pages/"+viewId;
	}
 	
 	/**
 	 * Sets debug flag
 	 * @param debug
 	 */
 	public void setDebug(String debug){
 		debugContainer = debug;
 	}
	
 	/**
 	 * Returns debug flag
 	 * @return
 	 */
 	public String getDebug(){
 		return debugContainer;
 	}
 	
}
