/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
if(!dojo._hasResource["org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore"] = true;
dojo.provide("org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore");

dojo.declare("org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore", null , {
	constructor: function( keywordParameters){
	},		
	widgetMap: {},
	getWidgetProperties: function(keywordArgs) {
		if ((this.widgetMap == null) || (this.widgetMap[keywordArgs.tags] == null) || (typeof(this.widgetMap[keywordArgs.tags]) == 'undefined')){
			var self = this;
			this.loadProperties({tag:keywordArgs.tags, onItem:function(data){
				self.widgetMap[keywordArgs.tags]=data;
				var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
				keywordArgs.onItem.call(scope, data);
			}});
		}
		else{
				var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
				keywordArgs.onItem.call(scope, this.widgetMap[keywordArgs.tags]);
		}
	},
		
	loadProperties: function(keywordArgs){
		// Callback for handling a successful load.
		var gotData = function(data){

			//Done processing!  Call the onItem, if any.
			if(keywordArgs.onItem){
				var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
				keywordArgs.onItem.call(scope, data);
			}
		};

		//Callback for any errors that occur during load.
		var gotError = function(error){
			//Call the onComplete, if any
			if(keywordArgs.onError){
				var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
				keywordArgs.onError.call(scope, error);
			}
		};

		//Fire the get and pass the proper callbacks to the deferred.
		var xhrArgs = {
			url: "WidgetPropertiesJSON?tag="+keywordArgs.tag,
			handleAs: "json-comment-optional"
		};
		var d = dojo.xhrGet(xhrArgs);
		d.addCallback(gotData);
		d.addErrback(gotError);
	}
});


}
