/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
dojo.provide("org.eclipse.cosmos.provisional.dr.ps.components.utility.UIContext");
dojo.require("org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore");
org.eclipse.cosmos.provisional.dr.ps.components.utility.UIContext = function () {
	this.initialize = function(){
		this.widgetStore = new org.eclipse.cosmos.provisional.dr.ps.components.data.WidgetStore();
		console.debug("initializing context");				
	 	dojo.publish("initializeWidget", [{context:this}]);	   
	},
	this.getStyleProperties = function(tag, onItem){		
		this.widgetStore.getWidgetProperties({tags:tag, onItem:onItem});
	},	
	this.createObject = function(prop, cell){       		
		//create widget		
		var properties = dojo.clone(prop);

		properties.UIContext = this;
		return eval("new "+properties.clazz+"(properties, cell)");
	
	},
	this.createWidgetView = function(tag, parentWidget, widgetCallback, cell){
		var self = this;
   		this.getStyleProperties(tag, function(data){
   			var style = dojo.clone(data);
   			if ((style) && (style.view)){
	   			style.view.parentWidget = parentWidget;
	   			
	   			var widgetProperties = style.view;
				widgetProperties.UIContext = self;
				widgetProperties.dataMap = style.dataMap;
				var viewObject = dojo.getObject(widgetProperties.clazz);
				if (dojo.isFunction(viewObject)){
					//We need to see if this is a pure function or an object constructor...
					var widget = new viewObject(widgetProperties, cell);
				//call callback to with widget			
					if (widgetCallback)
						widgetCallback(widget);
					return true;
				}
			}
			return false;
   		});
		
	},	
	this.submitQuery=function(keyArgs){
		var item = keyArgs.item;
		var query = keyArgs.queryObject
			if (typeof(query["queryHandler"]) != 'undefined'){
				//map input item to parameters of the query
				var postData = "";
				if (query.bindInput){
					query.bindInput(item, function(postData){
						var deferred = dojo.rawXhrPost({
						        url: query["queryHandler"],
						        handleAs: "json",
						        postData: postData,
						        render: query.render,        
						        onItem: keyArgs.onItem,
						        timeout: 5000, //Time in milliseconds
						        handle: function(response, ioArgs){
						                //This function handles the response.
						                //Inside this function, the "this" variable
						                //will be the object used as the argument to the dojo.xhrGet() call.
						                if(response instanceof Error){
						                        if(response.dojoType == "cancel"){
						                                //The request was canceled by some other JavaScript code.
						                                console.debug("Request canceled.");
						                        }else if(response.dojoType == "timeout"){
						                                //The request took over 5 seconds to complete.
						                                console.debug("Request timed out.");
						                        }else{
						                                //Some other error happened.
						                                console.error(response);
						                        }
						                }else{				
						                	//should only store the record contents so that we don't load the full graph response when loading the record viewer
						                	//check to see if we have to transform the response before sending the data to the call back method
						                	if (typeof(render) != 'undefined'){
					                        	this.onItem(render(response));
				                        	}
						                	else{
					                        	this.onItem(response);
				                        	}
						                }
						                //If you think there could be other callback handlers registered with this deferred, then
						                //return response to propagate the same response to other callback handlers. Otherwise,
						                //the error callbacks may be called in the success case.
						                return response;
						        }
						});		
					
					});
				}
			}
	},
 	dojo.subscribe("initialize", this, this.initialize);
 	return true;			
};

var uiContext = new org.eclipse.cosmos.provisional.dr.ps.components.utility.UIContext();
dojo.addOnLoad(
	function(e) {dojo.publish("initialize"); }
);




