/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
dojo.provide("org.eclipse.cosmos.provisional.dr.ps.components.widget.WidgetContainer");
dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");

 dojo.declare(
	'org.eclipse.cosmos.provisional.dr.ps.components.widget.WidgetContainer',
	[dijit._Widget, dijit._Container, dijit._Templated], 
	{
		widgetClass:'cosmos:WidgetContainer',
		templateString:"<div dojoAttachPoint=\"contentNode\">\n\t\t</div>\n",		
		childWidget: null,
		oldWidget: null,
		oldDiv: null,
		UIContext:null,
		attachPoint: null,
		postCreate: function(){
			//call superclass
			org.eclipse.cosmos.provisional.dr.ps.components.widget.WidgetContainer.superclass.postCreate.apply(this, arguments);
		  	dojo.subscribe("initializeWidget", this, this.initWidget);				
			dojo.subscribe(this.attachPoint, this, this.updateContainer);
			
		},		
		setChildWidget: function(widget){
				this.oldWidget = widget;		
		},
		updateContainer: function(message){
			if ((this.contentNode.childNodes) && (this.contentNode.childNodes.length>0)) {
				var nodeLength = this.contentNode.childNodes.length;
				for (var x =0; x<nodeLength; x++)				
					this.contentNode.removeChild(this.contentNode.childNodes[0]);
			}
			if (this.oldWidget != null){
				this.oldWidget.destroy();
				this.oldWidget = null;
			}
		
	    	if (typeof(message.contextMap) != 'undefined'){
				resourceClass = message.contextMap.nodeClass;	
			}
		
	    	if (typeof(resourceClass) != 'undefined'){
				try{
					var styleProp = this.attachPoint+" "+resourceClass;
					try{
						var contentNode = this.contentNode;
						this.oldDiv = document.createElement("div");
						this.contentNode.appendChild(this.oldDiv);
						var oldDiv = this.oldDiv;
						if ((styleProp)  && (typeof(styleProp) != 'undefined')){
							this.UIContext.context.createWidgetView(styleProp, this, function(widget){
									if (widget == null){
										contentNode.removeChild(oldDiv);							
									}
								}, oldDiv);
							
						}
					}catch(e){
						console.debug(e);
						this.contentNode.removeChild(oldDiv);
					}							
				}catch(e){
					console.debug(e);
				}
			}
	    },		
		initWidget: function(UIContext){
			if ((this.contentNode.childNodes) && (this.contentNode.childNodes.length>0)) {
				var nodeLength = this.contentNode.childNodes.length;
				for (var x =0; x<nodeLength; x++)				
					this.contentNode.removeChild(this.contentNode.childNodes[0]);
			}
			if (this.oldWidget != null){
				this.oldWidget.destroy();
				this.oldWidget = null;
			}
			this.UIContext = UIContext;		
			if (this.attachPoint != null){
					try{
						var contentNode = this.contentNode;
						this.oldDiv = document.createElement("div");
						this.contentNode.appendChild(this.oldDiv);	
							var self = this;							
							var oldDiv = this.oldDiv;	
							this.UIContext.context.createWidgetView(this.attachPoint, this, function(widget){
									if (widget == null){
										contentNode.removeChild(oldDiv);							
									}
								}, oldDiv);
					}catch(e){
						console.debug(e);
						this.contentNode.removeChild(this.oldDiv);
					}						
			}
	    }
	    
	}
);
